base/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView

api_patterns = [
    path("public/", include("api.public.urls")),
    path("schema/", SpectacularAPIView.as_view(), name="schema"),
    path("docs/", SpectacularSwaggerView.as_view(), name="swagger-ui"),
]

urlpatterns = [
    path(f"{settings.BASE_URL}admin/", admin.site.urls),
    path(f"{settings.BASE_URL}api/", include(api_patterns)),
    path(f"{settings.BASE_URL}auth/", include("authentication.urls")),
    path(f"{settings.BASE_URL}submit/", include("submitter.urls")),
]

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns.append(path("__debug__/", include("debug_toolbar.urls")))

submitter/urls.py
from django.contrib.auth.decorators import login_required
from django.urls import path

from .api_validation_views import (
    ValidateChebiName,
    ValidateSynonym,
    HtmxSubmitCompoundGetSources,
    GetChemicalDataFromMol,
    GetMassFromFormula,
    SpeciesSearch,
    ComponentSearch,
    GetSourceAccessionField,
)
from .views.profile import SubmitterHomeView, SubmitterProfileView
from .views.retrieve_compound import SubmitterEntityDetailView, SubmitterEntityListView
from .views.submit_compound import SubmitCompoundView
from .views.update_compound import (
    NamesUpdateView,
    HtmxUpdateCompoundGetSourceView,
    SubmitterCreateNameView,
    CompoundUpdateView,
    SubmitterCreateCrossReferenceView,
    SubmitterUpdateCrossReferenceView,
)

app_name = "submitter"

# All submitter views require login
# TODO: Can we move login_required decorator to base.urls?
urlpatterns = [
    path("", login_required(SubmitterHomeView.as_view()), name="dashboard"),
    path("new/", login_required(SubmitCompoundView.as_view()), name="submit-new"),
    path("profile/", login_required(SubmitterProfileView.as_view()), name="profile"),
    path("CHEBI:<pk>/", login_required(SubmitterEntityDetailView.as_view()), name="entity-detail"),
    path("CHEBI:<pk>/edit/", login_required(CompoundUpdateView.as_view()), name="edit-entity"),
    path("name/<pk>/update/", login_required(NamesUpdateView.as_view()), name="name-update"),
    path("CHEBI:<pk>/add-synonym/", login_required(SubmitterCreateNameView.as_view()), name="add-synonym"),
    path("CHEBI:<pk>/add-xref/", login_required(SubmitterCreateCrossReferenceView.as_view()), name="add-xref"),
    path("xref/<pk>/edit/", login_required(SubmitterUpdateCrossReferenceView.as_view()), name="update-xref"),
    path("my-submissions/", login_required(SubmitterEntityListView.as_view()), name="my-submissions"),
    # HTMX Views
    path("validate/name/", login_required(ValidateChebiName.as_view()), name="validate_chebi_name"),
    path(
        "validate/source/<str:form_type>/",
        login_required(HtmxSubmitCompoundGetSources.as_view()),
        name="validate_source",
    ),
    path("validate/synonym/", login_required(ValidateSynonym.as_view()), name="validate_synonym"),
    path(
        "validate/mol_to_chemical_data/", login_required(GetChemicalDataFromMol.as_view()), name="mol_to_chemical_data"
    ),
    path("validate/formula_to_mass/", login_required(GetMassFromFormula.as_view()), name="formula_to_mass"),
    path("validate/species/", login_required(SpeciesSearch.as_view()), name="species_search"),
    path("validate/component/", login_required(ComponentSearch.as_view()), name="component_search"),
    path(
        "validate/source_accession/",
        login_required(GetSourceAccessionField.as_view()),
        name="get_source_accession_field",
    ),
    path("htmx/get/source/", login_required(HtmxUpdateCompoundGetSourceView.as_view()), name="htmx_get_source"),
]

submitter/views/profile.py
from django.contrib.messages.views import SuccessMessageMixin
from django.urls import reverse_lazy
from django.views.generic import TemplateView, UpdateView

from chebi_models.models import User

from submitter.forms.update_forms import (
    SubmitterProfileForm,
)


class SubmitterHomeView(TemplateView):
    template_name = "submitter/dashboard.html"


class SubmitterProfileView(SuccessMessageMixin, UpdateView):
    model = User
    form_class = SubmitterProfileForm
    template_name = "submitter/profile.html"
    success_url = reverse_lazy("submitter:profile")
    success_message = "Profile has been updated"

    def get_object(self, queryset=None):
        return self.request.user

submitter/views/retrieve_compound.py
from django.contrib import messages
from django.http import Http404
from django.shortcuts import get_object_or_404
from django.views.generic import DetailView, ListView
from libRDChEBI.depiction import depict
from django.db.models import Q

from chebi_models.models import Compound


class SubmitterEntityListView(ListView):
    model = Compound
    template_name = "submitter/compound_list.html"
    paginate_by = 20
    ordering = "-pk"

    def get_queryset(self):
        qs = super().get_queryset().filter(created_by=self.request.user)
        search_keyword = self.request.GET.get("keyword")
        if search_keyword:
            qs = qs.filter(Q(name__icontains=search_keyword) | Q(chebi_accession__icontains=search_keyword))
        return qs


class SubmitterEntityDetailView(DetailView):
    model = Compound
    template_name = "submitter/compound-detail/index.html"

    def get_object(self, queryset=None):
        # Return parent object if it exists
        compound_obj = get_object_or_404(Compound.objects.all(), pk=self.kwargs.get("pk"))

        if (
            compound_obj.created_by != self.request.user
            and not compound_obj.children.filter(created_by=self.request.user).exists()
        ):
            # Return 404 if the current user did not create this entry or any of its children
            raise Http404

        if compound_obj.parent:
            messages.info(
                self.request,
                f"{compound_obj.chebi_accession} has been merged by ChEBI curators. You are now viewing details of "
                f"its parent entry.",
            )
            return compound_obj.parent
        return compound_obj

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context["submitters"] = (
            Compound.objects.filter(pk__in=self.object.compound_with_children_ids, created_by__is_anonymous=False)
            .values_list("created_by__public_name", flat=True)
            .distinct()
        )
        context["compound_with_children"] = [self.object] + list(self.object.children.all().order_by("pk"))
        if self.object.default_structure:
            context["default_structure_svg"] = depict(
                self.object.default_structure.molfile, maxFontSize=50, width=400, height=400
            )
        return context

submitter/views/submit_compound.py
from django.contrib import messages
from django.shortcuts import redirect
from django.views.generic import FormView

from chebi_models.models import Compound, Names, DatabaseAccession, CompoundOrigins

from submitter.forms.submit_forms import (
    SubmitCompoundForm,
    NamesFormSet,
    DatabaseAccessionFormSet,
    ChemicalDataForm,
    CompoundOriginsFormSet,
)
from submitter.utils import (
    save_names_formset,
    save_database_accessions_formset,
    save_compound_origins_formset,
    get_default_submitter_status,
)


class SubmitCompoundView(FormView):
    model = Compound
    template_name = "submitter/submit.html"
    form_class = SubmitCompoundForm
    formset_class = NamesFormSet

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.chemical_data_form = None
        self.names_formset = None
        self.database_accession_formset = None
        self.compound_origins_formset = None

    def form_valid(self, form):
        """If the form is valid, redirect to entry detail page"""
        messages.success(self.request, "Entry has been submitted successfully")
        return redirect("submitter:entity-detail", pk=form.instance.pk)

    def get_formsets(self, data=None):
        """Initialize formsets with or without data."""
        self.chemical_data_form = ChemicalDataForm(data) if data else ChemicalDataForm()
        self.names_formset = (
            NamesFormSet(data, prefix="names") if data else NamesFormSet(queryset=Names.objects.none(), prefix="names")
        )
        self.database_accession_formset = (
            DatabaseAccessionFormSet(data, prefix="database-accession")
            if data
            else DatabaseAccessionFormSet(queryset=DatabaseAccession.objects.none(), prefix="database-accession")
        )
        self.compound_origins_formset = (
            CompoundOriginsFormSet(data, prefix="compound-origins")
            if data
            else CompoundOriginsFormSet(queryset=CompoundOrigins.objects.none(), prefix="compound-origins")
        )

    def validate_all_forms(self, *forms):
        all_valid = True
        for form in forms:
            if not form.is_valid():
                all_valid = False
        return all_valid

    def get(self, request, *args, **kwargs):
        self.get_formsets(data=None)
        return super().get(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        """
        Handle POST requests: instantiate a form instance with the passed
        POST variables and then check if it's valid.
        """
        form = self.get_form()
        self.get_formsets(request.POST)
        if self.validate_all_forms(
            form,
            self.names_formset,
            self.database_accession_formset,
            self.chemical_data_form,
            self.compound_origins_formset,
        ):
            # If form and all nested forms are valid, then create the compound
            compound = form.save()
            # Initialise instances for nested forms
            database_accessions = self.database_accession_formset.save(commit=False)
            names = self.names_formset.save(commit=False)
            compound_origins = self.compound_origins_formset.save(commit=False)
            default_status = get_default_submitter_status()
            # Save nested formsets
            save_names_formset(names=names, compound=compound, status=default_status, created_by=request.user)
            save_compound_origins_formset(
                compound_origins=compound_origins, compound=compound, status=default_status, created_by=request.user
            )
            save_database_accessions_formset(
                database_accessions=database_accessions,
                compound=compound,
                status=default_status,
                created_by=request.user,
            )
            # Extract molfile of default structure and pass it to save_chemical_data
            self.chemical_data_form.save_with_structure(
                compound=compound,
                status=default_status,
                created_by=request.user,
                molfile=self.chemical_data_form.data.get("mol_default_structure"),
            )

            return self.form_valid(form)
        else:
            return self.form_invalid(form)

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs.update({"user": self.request.user})
        return kwargs

    def get_context_data(self, **kwargs):
        kwargs = super().get_context_data(**kwargs)
        kwargs.update({"chemical_data_form": self.chemical_data_form})
        kwargs.update({"names_formset": self.names_formset})
        kwargs.update({"database_accession_formset": self.database_accession_formset})
        kwargs.update({"compound_origins_formset": self.compound_origins_formset})
        return kwargs

templates/submitter/compound_list.html
{% extends "base.html" %}

{% block page_heading %}My Submissions{% endblock %}

{% block content %}
    {% load custom_filters %}
    <div class="row">
        <div class="col">
            <form>
                <div class="float-right search btn-group justify-content-right">
                    <input class="form-control search-input" type="search" placeholder="ChEBI Name or ID" name="keyword" value="{{ request.GET.keyword }}" />
                </div>
                <button type="submit" class="btn btn-outline-success">Search</button>
            </form>
        </div>
    </div>

    <table class="table table-striped table-hover my-5">
        <thead>
        <tr>
            <th scope="col">ChEBI ID</th>
            <th scope="col">Name</th>
            <th scope="col">Stars</th>
            <th scope="col">Definition</th>
            <th scope="col">Submission Date</th>
        </tr>
        </thead>
        <tbody>
        {% for obj in object_list %}
            <tr>
                <td>
                    <a class="text-decoration-none" href="{% url 'submitter:entity-detail' obj.pk %}">{{ obj.chebi_accession }}</a>
                    {% if obj.parent %}
                        <i class="bi bi-exclamation-circle-fill text-info" data-bs-toggle="tooltip" title="This entry has been merged into {{ obj.parent.chebi_accession }}"></i>
                    {% endif %}
                </td>
                <td>{{ obj.name }}</td>
                <td>{{ obj.stars }}</td>
                <td>{{ obj.definition }}</td>
                <td>{{ obj.created_on }}</td>
            </tr>
        {% empty %}
            <td colspan="5">No submissions found.</td>
        {% endfor %}
        </tbody>
    </table>

    <div class="col">
        Showing {{ page_obj.start_index }} to {{ page_obj.end_index }} of {{ page_obj.paginator.count }} results
    </div>

    <nav aria-label="Page navigation example">
        <ul class="pagination justify-content-center">
            {% if page_obj.has_previous %}
                <li class="page-item">
                    <a class="page-link" href="?{% url_replace request 'page' 1 %}" aria-label="First">&laquo;</a>
                </li>
                <li class="page-item"><a class="page-link"
                                         href="?{% url_replace request 'page' page_obj.previous_page_number %}">{{ page_obj.previous_page_number }}</a>
                </li>
            {% endif %}
            <li class="page-item active"><a class="page-link" href="#">{{ page_obj.number }}</a></li>

            {% if page_obj.has_next %}
                <li class="page-item"><a class="page-link"
                                         href="?{% url_replace request 'page' page_obj.next_page_number %}">{{ page_obj.next_page_number }}</a>
                </li>
                <li class="page-item"><a class="page-link" href="?{% url_replace request 'page' page_obj.paginator.num_pages %}"
                                         aria-label="Last">&raquo;</a></li>
            {% endif %}
        </ul>
    </nav>
{% endblock %}

templates/submitter/dashboard.html
{% extends "base.html" %}

{% block content %}
    <div class="container">
        Submitter Dashboard
    </div>
{% endblock %}

{% block extrastyle %}
    <style></style>
{% endblock %}

templates/submitter/profile.html
{% extends "base.html" %}

{% block content %}
    <div class="d-flex justify-content-center align-items-center">
        <div class="col-lg-6 col-md-8 d-flex flex-column align-items-center justify-content-center">
            <div class="card text-dark" style="width: 100%">
                <div class="card">
                    <div class="card-body">
                        <div class="pt-4 pb-2">
                            <h5 class="card-title text-center pb-0 fs-4">My Profile</h5>
                            <p class="text-center">You can update your submitter profile here.</p>
                        </div>
                        <form method="post">{% csrf_token %}
                            <div class="row">
                                <div class="col">
                                    {{ form }}
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-12 mt-3 col-md-12 mb-3 submit-row" style="text-align: -webkit-center">
                                    <button type="submit" class="btn btn-primary">Update</button>
                                </div>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

templates/submitter/submit.html
{% extends "base.html" %}
{% load static %}

{% block page_heading %}Submit Compound{% endblock %}

{% block content %}
    <div id="htmx-loader"  class="htmx-loader-overlay htmx-indicator">
        <div class="spinner-border" role="status"></div>
    </div>
    {{ form.non_field_errors }}
    <form method="post" class="m-5">
        {% csrf_token %}
        <div class="row">
            <div class="col-md-6">
                {{ form.name.as_field_group }}
            </div>
            <div class="col-md-6">
                {{ form.definition.as_field_group }}
            </div>
        </div>

    <div class="row m-3">
        <div class="col">
            <div id="sketch"></div>
        </div>
        <div class="col m-auto">
            <div id="chemical_data_container">
                {{ chemical_data_form.formula.as_field_group }}
                <div class="mb-3 row align-items-center">
                    <label for="id_charge" class="col-form-label col-auto me-2">Charge:</label>
                    <div class="col">
                        <input type="number" name="charge" class="form-control" id="id_charge" value="0">
                    </div>
                </div>
                <div id="chemical-data-mass-container">
                    <div class="mb-3">
                        <label class="readonly-properties-label">Average Mass:</label>
                    </div>
                    <div class="mb-3">
                        <label class="readonly-properties-label">Monoisotopic Mass:</label>
                    </div>
                </div>
                <div class="mb-3">
                    <label class="readonly-properties-label">InChI:</label>
                </div>
                <div class="mb-3">
                    <label class="readonly-properties-label">InChIKey:</label>
                </div>
                <div class="mb-3">
                    <label class="readonly-properties-label">SMILES:</label>
                </div>
                {{ chemical_data_form.mol_default_structure }}
            </div>
        </div>
    </div>

        <div class="row m-3">
            {% include 'submitter/partials/submit-synonyms-container.html' %}
        </div>

        <div class="row m-3">
            {% include 'submitter/partials/submit-database-accession-container.html' %}
        </div>

        <div class="row m-3">
            {% include "submitter/partials/submit-compound-origins-container.html" %}
        </div>

        <div class="row m-3">
            <div class="col-md-6">
                {{ form.release_date.as_field_group }}
            </div>
            <div class="col-md-6">
                {{ form.submitter_notes.as_field_group }}
            </div>
        </div>

        <div class="row m-auto justify-content-center">
            <div class="col-auto">
                <button type="submit" class="mt-3 btn btn-success">Submit Compound</button>
            </div>
        </div>
    </form>
{% endblock %}

{% block script %}
    <script src="{% static 'js/htmx.min.js' %}" defer></script>
    <script src="{{ MARVIN_JS_BASE_URL }}js/client/client.js"></script>
    <link href="{% static 'select2/select2-4.1.0.min.css' %}" rel="stylesheet" />
    <script src="{% static 'select2/select2-4.1.0.min.js' %}" defer></script>
    <link rel="stylesheet" href="{% static 'css/submitter.css' %}">
    <script>
    function addInlineForm(formType) {
        let formCount = document.getElementById(`id_${formType}-TOTAL_FORMS`).value;
        let container = document.getElementById(`${formType}-formset-container`);

        const emptyFormTemplate = document.getElementById(`${formType}-empty-form-template`).innerHTML;
        const newFormHtml = emptyFormTemplate.replace(/__prefix__/g, formCount);

        const tempDiv = document.createElement('div');
        tempDiv.innerHTML = newFormHtml;
        
        container.appendChild(tempDiv);

        document.getElementById(`id_${formType}-TOTAL_FORMS`).value = parseInt(formCount) + 1;
        htmx.process(document.body);
    }

    function removeInlineForm(button, formType) {
        // Mark the form for deletion and hide it from UI
        let formRow = button.closest(`.${formType}-form-row`);
        formRow.style.display = "none";
        formRow.querySelectorAll('input, textarea, select').forEach(function (input) {
            if (input.type === 'checkbox') {
                input.checked = true;
            } else {
                input.value = '';
            }
        });
    }

    function molChange(eventType) {
        editor.exportStructure('mol').then(function (mol) {
            htmx.ajax('POST', '{% url 'submitter:mol_to_chemical_data' %}', {
                target: "#chemical_data_container",
                values: { mol: mol },
            });
        });
    }

    document.addEventListener('DOMContentLoaded', function () {
        ChemaxonMarvinJs.createEditor("sketch", '{{ MARVIN_JS_BASE_URL }}').then(function (e) {
            editor = e;
            editor.on('molchange', function () {
                molChange("molchange");
            });
        });

        document.body.addEventListener('htmx:configRequest', function(event) {
            event.detail.headers['X-CSRFToken'] = '{{ csrf_token }}';
        });
    });

    function initializeSelect2Field(selector, placeholder, searchUrl) {
        $(selector).select2({
            width: '100%',
            allowClear: true,
            placeholder: placeholder,
            minimumInputLength: 2,
            ajax: {
                url: searchUrl,
                dataType: 'json',
                delay: 250,
                data: params => ({ q: params.term }),
                processResults: data => ({ results: data.results }),
            }
        });

        {# When the form is reloaded, and if there were any errors, we extract value of select2 field and render it again for clarity to user #}
        const initialValue = $(selector).val();
        if (initialValue) {
            const [text, id] = initialValue.split('$');
            const option = new Option(text, id, true, true);
            $(selector).append(option).trigger('change');
        }
    }

    function initializeSelect2Fields() {
        $('#compound-origins-formset-container .species-text-select').each(function() {
            initializeSelect2Field(this, 'Search existing or add new if not found', '{% url "submitter:species_search" %}');
        });

        $('#compound-origins-formset-container .component-text-select').each(function() {
            initializeSelect2Field(this, 'Search existing or add new if not found', '{% url "submitter:component_search" %}');
        });

        {# When an option is selected in select2 field, copy it to its relevant fields too #}
       $('#compound-origins-formset-container').on('select2:select', '.species-text-select', function(e) {
            const selectedData = e.params.data;
            const option = new Option(selectedData.text, selectedData.id, true, true);
            const $currentRow = $(this).closest('div.compound-origins-form-row');
            $currentRow.find('input.species-text-select').empty().append(option).trigger('change');
            $currentRow.find('input[name$="-species_text"]').val(selectedData.id.split('@')[0]);
            $currentRow.find('input[name$="-species_accession"]').val(selectedData.id.split('@')[1]);
            $currentRow.find('select[name$="-species_source"]').val(selectedData.id.split('@')[2]);
        });

       $('#compound-origins-formset-container').on('select2:select', '.component-text-select', function(e) {
            const selectedData = e.params.data;
            const option = new Option(selectedData.text, selectedData.id, true, true);
            const $currentRow = $(this).closest('div.compound-origins-form-row');
            $currentRow.find('input.component-text-select').empty().append(option).trigger('change');
            $currentRow.find('input[name$="-component_text"]').val(selectedData.id.split('@')[0]);
            $currentRow.find('input[name$="-component_accession"]').val(selectedData.id.split('@')[1]);
        });

       $("#compound-origins-formset-container").on('select2:clear', '.species-text-select', function (e) {
           const $currentRow = $(this).closest('div.compound-origins-form-row');
           $currentRow.find('input.species-text-select').empty().trigger('change');
           $currentRow.find('input[name$="-species_text"]').val('');
           $currentRow.find('input[name$="-species_accession"]').val('');
           $currentRow.find('select[name$="-species_source"]').val('');
       });

       $("#compound-origins-formset-container").on('select2:clear', '.component-text-select', function (e) {
            const $currentRow = $(this).closest('div.compound-origins-form-row');
            $currentRow.find('input.component-text-select').empty().trigger('change');
            $currentRow.find('input[name$="-component_text"]').val('');
            $currentRow.find('input[name$="-component_accession"]').val('');
       });
    }

    function expandSelect2ManualEntryFields(fieldSelector, containerSelector) {
        {# Expands the fields container for manually entering species and component data if select 2 is empty #}
        {# It is helpful for user to see expanded the manual fields if form is rendered again with errors #}
        const fields = document.querySelectorAll(`#compound-origins-formset-container ${fieldSelector}`);
        fields.forEach((field) => {
            if (field.value.trim() === "") {
                const formRow = field.closest(".compound-origins-form-row");
                const container = formRow.querySelector(containerSelector);
                // Get all select and input fields within the container
                const relatedFields = container.querySelectorAll("select, input");
                // Check if at least one of these fields is not empty
                const isAnyFieldNotEmpty = Array.from(relatedFields).some(field => field.value.trim() !== "");
                if (isAnyFieldNotEmpty) {
                    container.style.display = 'inherit';
                }
            }

            if (field.value.trim() !== "") {
                const formRow = field.closest(".compound-origins-form-row");
                const container = formRow.querySelector(containerSelector);
                const relatedFields = container.querySelectorAll("select, input");
                // Check if at least one of these fields is empty
                const isAnyFieldEmpty = Array.from(relatedFields).some(field => field.value.trim() === "");
                if (isAnyFieldEmpty) {
                    container.style.display = 'inherit';
                }
            }
        });
    }

    $(document).ready(function() {
        initializeSelect2Fields();
        expandSelect2ManualEntryFields(".species-text-select", ".species-fields-container");
        expandSelect2ManualEntryFields(".component-text-select", ".component-fields-container");
   });

   function addInlineCompoundOriginsForm(){
       addInlineForm('compound-origins');
       initializeSelect2Fields();
   }

   function toggleCompoundOriginFields(checkbox, targetClass){
       {# Utility function that show/hides comments and strain fields  #}
       const formRow = checkbox.closest('.compound-origins-form-row');
       const commentDiv = formRow.querySelector(targetClass);
       if (commentDiv) {
           commentDiv.style.display = checkbox.checked ? 'inherit' : 'none';
       }
   }

   function hideSelect2Field(trigger, event, target){
       event.preventDefault();
       const formRow = trigger.closest('.compound-origins-form-row');
       formRow.querySelector("." + target + "-fields-container").style.display = 'inherit';
   }
    </script>
{% endblock %}